Otus.Teaching.PromoCodeFactory.Mvc/Controllers/CustomersController.cs
using Microsoft.AspNetCore.Mvc;
using Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement;
using Otus.Teaching.PromoCodeFactory.Core.Interfaces.Repositories;
using Otus.Teaching.PromoCodeFactory.Mvc.Models;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace Otus.Teaching.PromoCodeFactory.Mvc.Controllers
{
    public class CustomersController : Controller
    {
        private readonly IRepository<Customer> _customerRepository;

        public CustomersController(IRepository<Customer> customerRepository)
        {
            _customerRepository = customerRepository;
        }

        public async Task<IActionResult> Index()
        {
            var customers  =  await _customerRepository.GetAllAsync();
            return View(customers.Select(x => new CustomerShortViewModel(x)));
        }
        
        public async Task<IActionResult> Details(Guid id)
        {
            
            var customer = await _customerRepository.GetByIdAsync(id);

            if (customer == null)
            {
                return NotFound();
            }
            
            return View(new CustomerViewModel(customer));
        }
        
        public IActionResult Create()
        {
            return View();
        }
        
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CustomerShortViewModel request)
        {
            if (!ModelState.IsValid) 
                return View(request);

            var customer = new Customer()
            {
                Email = request.Email,
                FirstName = request.FirstName,
                LastName = request.LastName
            };

            await _customerRepository.AddAsync(customer);

            return RedirectToAction(nameof(Details), new {id = customer.Id});
        }

        public async Task<IActionResult> Edit(Guid id)
        {
            var customer = await _customerRepository.GetByIdAsync(id);

            if (customer == null)
            {
                return NotFound();
            }

            return View(new CustomerShortViewModel(customer));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(CustomerShortViewModel request)
        {
            if (!ModelState.IsValid) 
                return View(request);

            var customer = await _customerRepository.GetByIdAsync(request.Id);

            if (customer == null)
                return NotFound();

            customer.Email = request.Email;
            customer.FirstName = request.FirstName;
            customer.LastName = request.LastName;
            
            await _customerRepository.UpdateAsync(customer);

            return RedirectToAction(nameof(Details), new { id= request.Id });
        }
        
        public async Task<IActionResult> ConfirmDelete(Guid id)
        {
            var customer = await _customerRepository.GetByIdAsync(id);

            if (customer == null)
            {
                return NotFound();
            }

            return View("Delete", new CustomerShortViewModel(customer));
        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Delete(Guid id)
        {
            var customer = await _customerRepository.GetByIdAsync(id);

            if (customer == null)
                return NotFound();

            await _customerRepository.DeleteAsync(customer);

            return RedirectToAction(nameof(Index));
        }

    }
}

Otus.Teaching.PromoCodeFactory.Mvc/Controllers/PreferencesController.cs
using Microsoft.AspNetCore.Mvc;
using Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement;
using Otus.Teaching.PromoCodeFactory.Core.Interfaces.Repositories;
using Otus.Teaching.PromoCodeFactory.Mvc.Models;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace Otus.Teaching.PromoCodeFactory.Mvc.Controllers
{
    public class PreferencesController : Controller
    {
        private readonly IRepository<Preference> _preferencesRepository;

        public PreferencesController(IRepository<Preference> preferencesRepository)
        {
            _preferencesRepository = preferencesRepository;
        }

        public async Task<IActionResult> Index()
        {
            var preferences =  await _preferencesRepository.GetAllAsync();

            var response = preferences.Select(x => new PreferenceViewModel(x)).ToList();

            return View(response);
        }
        

        public async Task<IActionResult> Details(Guid id)
        {

            var preference = await _preferencesRepository.GetByIdAsync(id);

            if (preference == null)
            {
                return NotFound();
            }

            return View(new PreferenceViewModel(preference));
        }

        
        public IActionResult Create()
        {
            return View();
        }

        

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(PreferenceViewModel request)
        {
            if (!ModelState.IsValid) 
                return View(request);

            var preference = new Preference()
            {
                Name = request.Name
            };

            await _preferencesRepository.AddAsync(preference);

            return RedirectToAction(nameof(Details), new { id = preference.Id });
        }
        
        public async Task<IActionResult> Edit(Guid id)
        {

            var preference = await _preferencesRepository.GetByIdAsync(id);

            if (preference == null)
            {
                return NotFound();
            }

            return View(new PreferenceViewModel(preference));
        }

        

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(PreferenceViewModel request)
        {
            if (!ModelState.IsValid) 
                return View(request);

            var preference = await _preferencesRepository.GetByIdAsync(request.Id);

            if (preference == null)
                return NotFound();

            preference.Name = request.Name;

            await _preferencesRepository.UpdateAsync(preference);

            return RedirectToAction(nameof(Details), new { id = request.Id });
        }


        public async Task<IActionResult> ConfirmDelete(Guid id)
        {
            var preference = await _preferencesRepository.GetByIdAsync(id);

            if (preference == null)
            {
                return NotFound();
            }

            return View("Delete", new PreferenceViewModel(preference));
        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Delete(Guid Id)
        {
            var preference = await _preferencesRepository.GetByIdAsync(Id);

            if (preference == null)
                return NotFound();

            await _preferencesRepository.DeleteAsync(preference);

            return RedirectToAction(nameof(Index));
        }
        
    }
}

Otus.Teaching.PromoCodeFactory.Mvc/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Otus.Teaching.PromoCodeFactory.Mvc</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Razor</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-controller="Customers" asp-action="Index">Клиенты</a>
                        </li>

                        <li class="nav-item">
                            <a class="nav-link" asp-controller="Preferences" asp-action="Index">Предпочтения</a>
                        </li>

                        <li class="nav-item">
                            <a class="nav-link" asp-controller="Promocodes" asp-action="Index">Промокоды</a>
                        </li>

                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>

                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>

                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - Otus.Teaching.PromoCodeFactory.Mvc - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>